#include "fivewin.ch"
#include "treeview.ch"

STATIC oWnd
//----------------------------------------------------------------------------//
FUNCTION Main()

 LOCAL oBarra

   SET RESOURCES TO "Sample.dll"

   DEFINE WINDOW oWnd FROM 0,0 TO 400,600 PIXEL ;
          TITLE "TTreeView Class Power" MDI

       DEFINE BUTTONBAR oBarra OF oWnd SIZE 30,30 _3D // LABELS

       DEFINE BUTTON RESOURCE "Database","Database_m" OF oBarra ;
              MESSAGE "Trees en Ventanas ..." ACTION ChildTrees( lTreeOpen() ) ;
              NOBORDER TOOLTIP "Trees en Ventanas ..."

       DEFINE BUTTON ACTION TreeDlgCodigo()           OF oBarra ;
              RESOURCE "Editar" ;
              MESSAGE "Trees en Dialogos de Codigo ..."  ;
              NOBORDER TOOLTIP "Trees en Dialogos de Codigo ..."

       DEFINE BUTTON ACTION TreeDlgRecursos()         OF oBarra ;
              RESOURCE "Actualizar" ;
              MESSAGE "Trees en Dialogos de Recursos ..."  ;
              NOBORDER TOOLTIP "Trees en Dialogos de Recursos ..."


       SET MESSAGE OF oWnd KEYBOARD NOINSET

       ACTIVATE WINDOW oWnd

RETURN nil
//----------------------------------------------------------------------------//

FUNCTION ChildTrees( lAbierto )

   LOCAL oBarra
   LOCAL oChild
   LOCAL oTree

   DEFINE WINDOW oChild FROM 0,0 TO 400,600 PIXEL ;
          TITLE "Tree desde codigo en Ventana MDICHILD" MDICHILD ICON "Database"

   DEFINE BUTTONBAR oBarra OF oChild SIZE 28,29 _3D

   DEFINE BUTTON RESOURCE "Actualizar" OF oBarra ;
          MESSAGE "Actualizar base de datos ..." ACTION ( oTree:End(),;
          oChild:Refresh(.T.) ,;
          oTree := Trees( oChild, lAbierto ) ) ;
          NOBORDER TOOLTIP "Actualizar base de datos ..."

   DEFINE BUTTON RESOURCE "Color" OF oBarra GROUP ;
          MESSAGE "Selecciona color ..." ACTION oTree:SelColor();
          NOBORDER TOOLTIP "Selecciona color ..."


   SET MESSAGE OF oChild NOINSET
   DEFINE MSGITEM OF oChild:oMsgBar PROMPT "Child creado a las " + TIME() SIZE 150

   ACTIVATE WINDOW oChild ;
           ON INIT oTree := Trees(oChild, lAbierto )

RETURN NIL

//----------------------------------------------------------------------------//
FUNCTION Trees( oChild, lAbierto )

   LOCAL oDatabase
   LOCAL nStep
   LOCAL oTree
   LOCAL oLink

   @ 0, 0 TREE oTree OF oChild ;
     SIZE 0, 0 PIXEL ;
     BITMAPS { "Paper","FoldClose","FoldOpen", "BookClose", "BookOpen", "Tabla", "Procedimiento", "Usuario", "Server", "Ejecutivo", "Respaldo" } ;
     TREE STYLE nOr( TVS_HASLINES, TVS_HASBUTTONS ) ;
     ON DBLCLICK ClickTree(oTree) 

   oChild:SetControl(oTree)

   ArmarTree( oTree, lAbierto )


RETURN oTree

//----------------------------------------------------------------------------//
Function TreeDlgCodigo()
 LOCAL oDlg, oTree

    DEFINE DIALOG oDlg FROM 0,0 to 24,50 ;
           TITLE 'Trees desde Codigo en Dialogos SIN BORDE'
       oDlg:nStyle:= nOr( oDlg:nStyle, 4 ) // DS_3DLOOK Win9x

       @ 5, 5 TREE oTree OF oDlg ;
         SIZE 120,160  PIXEL ;
         BITMAPS { "Paper","FoldClose","FoldOpen", "BookClose", "BookOpen", "Tabla", "Procedimiento", "Usuario", "Server", "Ejecutivo", "Respaldo" } ;
         TREE STYLE nOr( TVS_HASLINES, TVS_HASBUTTONS );
         ON DBLCLICK ClickTree(oTree) NOBORDER

       @12, 23 BUTTON '&Ok' SIZE 30,10 OF oDlg

       ArmarTree( oTree, lTreeOpen() )

     ACTIVATE DIALOG oDlg CENTERED

return Nil

//----------------------------------------------------------------------------//
Function TreeDlgRecursos()
 LOCAL oDlg, oTree
    DEFINE DIALOG oDlg RESOURCE 'MAIN'

       REDEFINE TREE oTree ID 110 OF oDlg  ;
         BITMAPS { "Paper","FoldClose","FoldOpen", "BookClose", "BookOpen", "Tabla", "Procedimiento", "Usuario", "Server", "Ejecutivo", "Respaldo" } ;
         TREE STYLE nOr( TVS_HASLINES, TVS_HASBUTTONS ) ;
         ON DBLCLICK ClickTree(oTree)

       ArmarTree( oTree, lTreeOpen()  )


       REDEFINE BUTTON ID 120 OF oDlg ACTION ( ExpandTree( oTree ), ToArray( oTree ) )

       REDEFINE BUTTON ID 130 OF oDlg ACTION VerPadres( oTree )

       REDEFINE BUTTON ID 140 OF oDlg ACTION VerHijos( oTree )

       REDEFINE BUTTON ID 150 OF oDlg ACTION ExpandTree( oTree )


     ACTIVATE DIALOG oDlg CENTERED
return Nil

//----------------------------------------------------------------------------//
Function ArmarTree( oTree, lOpened )
   LOCAL oDatabase
   LOCAL nStep
   LOCAL oLink
   Local aArray := { {  1, "Servidor"                   } ,;
                     {  2, "Ejecutivo"                  },;
                     {  2, "Tablas"                     },;
                     {  3, "Tabla 1"                    },;
                     {  3, "Tabla 2"                    },;
                     {  3, "Tabla 3"                    },;
                     {  3, "Tabla 4"                    },;
                     {  3, "Tabla 5"                    },;
                     {  2, "Procedimientos"             },;
                     {  3, "Procedimiento 1"            },;
                     {  3, "Procedimiento 2"            },;
                     {  3, "Procedimiento 3"            },;
                     {  4, "Sub procesos   "            },;
                     {  5, "Sub proceso 1  "            },;
                     {  5, "Sub proceso 2  "            },;
                     {  5, "Sub proceso 3  "            },;
                     {  3, "Procedimiento 4"            },;
                     {  3, "Procedimiento 5"            },;
                     {  2, "Usuarios     "              },;
                     {  3, "Usuario 1    "              },;
                     {  3, "Usuario 2    "              },;
                     {  3, "Usuario 3    "              }}





   oTree:bRClicked = {|nRow,nCol|  MenuTree(oTree,nRow,nCol)}




   Array2Tree( oTree, aArray, lOpened )

   oTree:UpdateTV()

   oTree:SetFocus()

RETURN oTree

//----------------------------------------------------------------------------//
FUNCTION MenuTree( oTree, nRow, nCol )
   LOCAL nIndex  := oTree:GetCursel()
   LOCAL oLink := oTree:GetLinkAt( nIndex )
   LOCAL cPrompt := oLink:TreeItem:cPrompt
   LOCAL cParent
   LOCAL oMenu

   MENU oMenu POPUP

       DO CASE

          CASE cPrompt = "Servidor"
          CASE cPrompt = "Tablas"
               IF .t.
                  MENUITEM "Nueva" ACTION MsgInfo("Crea tabla") ;
                           RESOURCE "Crear" ;
                           MESSAGE "Edicin de las tablas ..."
               ELSE
                  MENUITEM "Edicion" ACTION MsgInfo("Modifica tabla") ;
                           RESOURCE "Estructura" ;
                           MESSAGE "Crear tabla ..."
               ENDIF
               SEPARATOR
               MENUITEM "Indices" ACTION MsgInfo("Modifica Indices");
                        MESSAGE "Indices ..."
               MENUITEM "Disparadores (Triggers)" ;
                        MESSAGE "Disparadores ..."
               SEPARATOR
               MENUITEM "Generar secuencia de comandos (Scripts)" ACTION MsgInfo("Genera Scripts") ;
                        MESSAGE "Generar secuencia de comandos ..."
          CASE cPrompt = "Procedimientos almacenados"
               IF .t. //oProcedure = nil
                  MENUITEM "Nuevo" ACTION "Crea procedimientos" ;
                           RESOURCE "Crear" ;
                           MESSAGE "Crear procedimientos ..."
               ELSE
                  MENUITEM "Edicion" ACTION "Actualiza procedimientos" ;
                           RESOURCE "Editar" ;
                           MESSAGE "Edicin de los procedimientos ..."
               ENDIF
               SEPARATOR
               MENUITEM "Generar secuencia de comandos (Scripts)"  ACTION "Genera Scripts" ;
                        MESSAGE "Generar secuencia de comandos ..."
          CASE cPrompt = "Usuarios"
               MENUITEM "Nuevo" ;
                        RESOURCE "Crear" ;
                        MESSAGE "Crear usuario ..."

          CASE cPrompt = "Respaldos"
               MENUITEM "Nuevo" ;
                        RESOURCE "Crear" ;
                        MESSAGE "Crear respaldo ..."

          OTHERWISE

               cParent = oLink:ParentLink:TreeItem:cPrompt

               DO CASE
                  CASE cParent = "Tablas"
                       MENUITEM "Nueva" ;
                                RESOURCE "Crear" ;
                                MESSAGE "Crear tabla ..."
                       MENUITEM "Editar" ACTION MsgInfo("Modificar tabla");
                                RESOURCE "Editar" ;
                                MESSAGE "Editar tabla ..."
                       MENUITEM "Eliminar (Drop)" ;
                                RESOURCE "Borrar" ;
                                MESSAGE "Eliminar tabla ..." ;
                                ACTION MsgInfo("Eliminar tabla")
                       SEPARATOR
                       MENUITEM "Editor de datos" ACTION "Editar datos" ;
                                RESOURCE "Datos" ;
                                MESSAGE "Editar datos de tabla ..."
                       SEPARATOR
                       MENUITEM "Renombrar" ;
                                MESSAGE "Renombrar tabla ..."
                       SEPARATOR
                       MENUITEM "Indices" ACTION MsgInfo("Indices");
                                MESSAGE "Indices ..."
                       MENUITEM "Disparadores (Triggers)" ;
                                MESSAGE "Disparadores ..."
                       SEPARATOR
                       MENUITEM "Generar secuencia de comandos (Scripts)" ACTION MsgInfo("Scripts");
                                MESSAGE "Generar secuencia de comandos ..."
                  CASE cParent = "Procedimientos almacenados"
                       MENUITEM "Nuevo" ;
                                RESOURCE "Crear" ;
                                MESSAGE "Crear procedimiento ..."
                       MENUITEM "Editar" ;
                                RESOURCE "Editar" ;
                                MESSAGE "Editar procedimiento ..."
                       MENUITEM "Eliminar (Drop)" ;
                                RESOURCE "Borrar" ;
                                MESSAGE "Eliminar procedimiento ..." ;
                                ACTION "Eliminar procedimiento"
                       SEPARATOR
                       MENUITEM "Renombrar" ;
                                MESSAGE "Renombrar procedimiento ..."
                       SEPARATOR
                       MENUITEM "Generar secuencia de comandos (Scripts)" ACTION MsgInfo("Generar scripts") ;
                                MESSAGE "Generar secuencia de comandos ..."
                  CASE cParent = "Usuarios"
                       MENUITEM "Nuevo" ;
                                RESOURCE "Crear" ;
                                MESSAGE "Crear usuario ..."
                       MENUITEM "Editar" ;
                                RESOURCE "Editar" ;
                                MESSAGE "Editar usuario ..."
                       MENUITEM "Eliminar (Drop)" ;
                                RESOURCE "Borrar" ;
                                MESSAGE "Eliminar usuario ..."
               ENDCASE

       ENDCASE

   ENDMENU

   ACTIVATE POPUP oMenu AT nRow,nCol OF oTree:oWnd

RETURN nil
//----------------------------------------------------------------------------//
FUNCTION ClickTree( oTree )

   LOCAL oLink := oTree:GetLinkAt( oTree:GetCursel() )
   LOCAL cPrompt := oLink:TreeItem:cPrompt
   LOCAL cParent

   IF AT( cPrompt , "Servidor" + ;
         "Ejecutivo" + ;
         "Tablas" + ;
         "Procedimientos almacenados" + ;
         "Usuarios" + ;
         "Respaldos" ) > 0

   ELSE

      cParent = oLink:ParentLink:TreeItem:cPrompt

      DO CASE
         CASE cParent = "Tablas"
              MsgInfo("a tablas ...")
         CASE cParent = "Procedimientos almacenados"
              MsgInfo("a procedimientos ...")
         CASE cParent = "Usuarios"
              MsgInfo("a usuarios ...")
      ENDCASE

   ENDIF

RETURN nil
//----------------------------------------------------------------------------//
STATIC Function lTreeOpen()
return ( MessageBox(, "Quiere el Tree Totalmente Abierto ?",;
         "-.Opcion.-", 1 ) == 1 )

//----------------------------------------------------------------------------//

Static Procedure ToArray( oTree )
   Local aArray := Tree2Array( oTree )
   Local n
   Local Lista := {}
   Local oDlg, oLst

  FOR n := 1 To  Len( aArray )
     aAdd( Lista, Space( aArray[ n, 1 ] * 2 )+ aArray[ n, 2 ] )
  NEXT

  ListaDlg( Lista, "El Arbol visto como Array" )
Return



Static Procedure VerPadres( oTree )
   Local aArray := Padres( oTree )
   Local Lista  := {}
   Local n

   FOR n := Len( aArray ) To 1 Step -1
      aAdd( Lista, Space( aArray[ n, 1 ] * 2 )+ aArray[ n, 2 ] )
   NEXT


   ListaDlg( Lista, "Los Padres de la criatura" )

Return

Static Procedure VerHijos( oTree )
   Local aArray := Hijos( oTree )
   Local Lista  := {}
   Local n

   FOR n := 1 To Len( aArray )
      aAdd( Lista, Space( aArray[ n, 1 ] * 2 )+ aArray[ n, 2 ] )
   NEXT

   ListaDlg( Lista, "Y el resto de la familia!!" )

Return




Static Procedure ListaDlg( Lista, cTitulo )
  Local oDlg, oLst

  DEFINE DIALOG oDlg RESOURCE "Listas"

    oDlg:cCaption  := cTitulo

    REDEFINE LISTBOX oLst ID 101                                               ;
                          ITEMS Lista  OF oDlg

  ACTIVATE DIALOG oDlg CENTERED

  oDlg:Destroy()

Return



