*******************************************************************************
*                            TreeFunc.Prg                                     *
*                                V. 1.1                                        *
*                                                                             *
*    Extensiones a la case TreeView de S.Goran y H. Ceccarelli                *
*                                                                             *
*    Tree2Array()   Transforma el rbol en array  { nivel, texto }            *
*    Array2Tree()   Transforma un array en rbol                              *
*    Padres()       Muestra los niveles superiores                            *
*    Hijos()        Muestra los niveles inferiores                            *
*    ExpandTree()   Abre todos los elementos del rbos                        *
*                                                                             *
*******************************************************************************
*  Fredy  11-03-2001          fredy@airtel.net       http://come.to/cincowin  *
*******************************************************************************
*Nota: Esta es una versin preliminar, o sea, seguro que tiene algn fallo :) *
*******************************************************************************
#include "treeview.ch"

                        // -- PASA UN TREE A UN ARRAY -- //
Function Tree2Array( oTree )
    Local aArray := {}

    CorreTree( oTree:GetNext( Nil, TVGN_ROOT ):FirstChild, aArray )

Return( aArray )



                        // -- PASA UN ARRAY A UN TREE -- //
Function Array2Tree( oTree, aArray, lOpened )
   Local oDatabase := oTree:GetRoot()
   Local oLink
   Local nIndex := 2
   Local nRamas := Len( aArray )
   Local Nivel
   Local Texto
   Local NextNivel
   Local aLink := {}

   Nivel    := aArray[ 1, 1 ]
   Texto    := aArray[ 1, 2 ]

   oDatabase := oDatabase:AddLastChild( Texto, 3, 2, lOpened )
   oLink     := oDatabase

   aAdd( aLink, oLink )

   DO WHILE nIndex <= nRamas
      Nivel     := aArray[ nIndex, 1 ]
      Texto     := aArray[ nIndex, 2 ]
      NextNivel := If( nIndex == nRamas, Nivel, aArray[ nIndex + 1 , 1 ] )

      IF Len( aLink ) < Nivel
         aAdd( aLink, oLink )
       ELSE
         aLink[ Nivel ] := oLink
      END IF

      DO CASE
         CASE Nivel <  NextNivel
                oLink := aLink[nivel]:AddLastChild( Texto, 3, 2, lOpened )
         CASE Nivel >  NextNivel
              oLink:AddLastChild( Texto, 3, 2, lOpened )
              oLink := aLink[ NextNivel ]
         CASE Nivel =  NextNivel
              aLink[nivel]:AddLastChild( Texto, 3, 2, lOpened )
      END CASE


      nIndex++
      SysRefresh()

   END DO

Return( oTree )


       // -- RETORNA UN ARRAY CON LOS PADRES DEL ELEMENTO SELECCIONADO -- //
Function Padres( oTree )
   Local lFirst := .t.
   Local oItem  := oTree:GetLinkAt( oTree:GetCurSel() )
   Local aArray := {}


   DO WHILE !oItem:IsRoot()

      IF oItem:IsParent() .And. !lFirst
        //aAdd( aArray, oItem:TreeItem:cPrompt )
        aAdd( aArray, { oItem:IndentLevel, oItem:TreeItem:cPrompt } )
      END IF

      oItem  := oItem:ParentLink
      lFirst := .f.

      SysRefresh()

   END DO

Return( aArray )



 // -- RETORNA UN ARRAY CON LOS ELEMENTOS DE LA RAMA DONDE NOS ENCONTRAMOS -- //
Function Hijos( oTree )
   Local aArray := {}

   IF oTree:GetNext( Nil, TVGN_CARET ):IsParent()
      CorreTree( oTree:GetNext( Nil, TVGN_CARET  ):FirstChild, aArray )
   ELSE
      CorreTree( oTree:GetNext( Nil, TVGN_PARENT ):FirstChild, aArray )
   END IF

Return( aArray )



                             // -- RECORRE EL ARBOL -- //
Static Function CorreTree( oItem , aArray)

   DO WHILE !Empty( oItem )

     IF oItem:IsParent()
        aAdd( aArray, { oItem:IndentLevel, oItem:TreeItem:cPrompt } )
        CorreTree( oItem:FirstChild, aArray )
     ELSE
        aAdd( aArray, { oItem:IndentLevel, oItem:TreeItem:cPrompt } )
     END IF

     oItem := oItem:NextSibling

     SysRefresh()

   END DO

Return


                      // -- ABRE EL ARBOL COMPLETAMENTE -- //
Function ExpandTree( oTree )
   Local aArray := Tree2Array( oTree )
   Local n

   FOR n := 1 TO Len( aArray )
       oTree:SetCursel( n )
       oTree:Expand( Nil, TVE_EXPAND )
       SysRefresh()
   NEXT
   oTree:SetCursel( 0 )

Return


